// Auto-generated. Do not edit!

// (in-package aruco_opencv_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MarkerPose = require('./MarkerPose.js');
let BoardPose = require('./BoardPose.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class ArucoDetection {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.markers = null;
      this.boards = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('markers')) {
        this.markers = initObj.markers
      }
      else {
        this.markers = [];
      }
      if (initObj.hasOwnProperty('boards')) {
        this.boards = initObj.boards
      }
      else {
        this.boards = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ArucoDetection
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [markers]
    // Serialize the length for message field [markers]
    bufferOffset = _serializer.uint32(obj.markers.length, buffer, bufferOffset);
    obj.markers.forEach((val) => {
      bufferOffset = MarkerPose.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [boards]
    // Serialize the length for message field [boards]
    bufferOffset = _serializer.uint32(obj.boards.length, buffer, bufferOffset);
    obj.boards.forEach((val) => {
      bufferOffset = BoardPose.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ArucoDetection
    let len;
    let data = new ArucoDetection(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [markers]
    // Deserialize array length for message field [markers]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.markers = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.markers[i] = MarkerPose.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [boards]
    // Deserialize array length for message field [boards]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.boards = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.boards[i] = BoardPose.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += 58 * object.markers.length;
    object.boards.forEach((val) => {
      length += BoardPose.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'aruco_opencv_msgs/ArucoDetection';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '8d4feeb18e86d4c984a2fea6995d1aea';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    std_msgs/Header header
    aruco_opencv_msgs/MarkerPose[] markers
    aruco_opencv_msgs/BoardPose[] boards
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: aruco_opencv_msgs/MarkerPose
    uint16 marker_id
    geometry_msgs/Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: aruco_opencv_msgs/BoardPose
    string board_name
    geometry_msgs/Pose pose
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ArucoDetection(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.markers !== undefined) {
      resolved.markers = new Array(msg.markers.length);
      for (let i = 0; i < resolved.markers.length; ++i) {
        resolved.markers[i] = MarkerPose.Resolve(msg.markers[i]);
      }
    }
    else {
      resolved.markers = []
    }

    if (msg.boards !== undefined) {
      resolved.boards = new Array(msg.boards.length);
      for (let i = 0; i < resolved.boards.length; ++i) {
        resolved.boards[i] = BoardPose.Resolve(msg.boards[i]);
      }
    }
    else {
      resolved.boards = []
    }

    return resolved;
    }
};

module.exports = ArucoDetection;
